<?php
class Calendarista_HolidayController extends Calendarista_BaseController{
	public function __construct($updateCallback){
		if (!(array_key_exists('controller', $_POST) 
			&& $_POST['controller'] == 'calendarista_holiday')){
			return;
		}
		parent::__construct(null, $updateCallback);
	}
	public function update($callback){
		$projectId = isset($_POST['projectId']) ? intval($_POST['projectId']) : null;
		$availabilityId = isset($_POST['availabilityId']) ? intval($_POST['availabilityId']) : null;
		$holidays = isset($_POST['holidays']) ? $_POST['holidays'] : array();
		$holidaysUndo = isset($_POST['holidays_undo']) ? array_map('intval', $_POST['holidays_undo']) : array();
		$repo = new Calendarista_HolidaysRepository();
		if(count($holidays) > 0){
			foreach($holidays as $holiday){
				$result = $repo->insert(array(
					'projectId'=>$projectId
					, 'availabilityId'=>$availabilityId
					, 'holiday'=>$holiday
				));
			}
		}
		if(count($holidaysUndo) > 0){
			foreach($holidaysUndo as $holidayId){
				$result = $repo->delete($holidayId);
			}
		}
		$this->executeCallback($callback, array($result));
	}
}
?>