<?php
class Calendarista_BookingAvailabilitySwitcherTmpl extends Calendarista_TemplateBase{
	public $availabilities = array();
	public $availability;
	public $availabilityId;
	public $searchResultAvailabilityId;
	public function __construct($availabilities, $searchResultAvailabilityId = null){
		parent::__construct();
		$this->availabilities = $availabilities;
		$this->searchResultAvailabilityId = $searchResultAvailabilityId;
		$this->availability = new Calendarista_Availability(array());
		$this->availabilityId = (int)$this->getPostValue('availabilityId');
		if(!$this->availabilityId){
			$this->availabilityId = (int)$this->getViewStateValue('availabilityId');
		}
		if(!$this->availabilityId){
			$this->availabilityId = $this->searchResultAvailabilityId;
		}
		if(count($this->availabilities) > 0){
			if(!$this->availabilityId){
				$this->availabilityId = $this->availabilities[0]->id;
			}
			$this->render();
		}
	}
	public function selectedValue($id){
		return $this->availabilityId === $id ? 'selected=selected' : '';
	}
	public function render(){
	?>
	<div class="availability_placeholder">
		<?php if(count($this->availabilities) > 1):?>
		<input type="hidden" name="oldAvailabilityId" />
		<input type="hidden" 
			name="availabilityId" 
			class="calendarista_parsley_validated" 
			data-parsley-required="true" 
			data-parsley-errors-messages-disabled="true" 
			value="<?php echo $this->availabilityId ?>" />
		<div class="col-xl-12">
			<div class="form-group">
				<label class="form-control-label calendarista-typography--caption1" for="availability_<?php echo $this->projectId; ?>">
					<?php echo $this->stringResources['BOOKING_AVAILABILITY_SELECTION_LABEL'] ?>
				</label>
				<select
					id="availability_<?php echo $this->projectId; ?>"
					name="availability" 
					class="form-control calendarista-typography--caption1">
					<?php foreach($this->availabilities as $availability):?>
					<option value="<?php echo $availability->id ?>" <?php echo $this->selectedValue($availability->id); ?>>
						<?php echo Calendarista_StringResourceHelper::decodeString($availability->name) ?>
					</option>
					<?php endforeach; ?>
				</select>
			</div>
		</div>
		<?php else: ?>
		<input type="hidden" 
			name="availabilityId" 
			value="<?php echo $this->availabilityId ?>" />
		<?php endif; ?>
	</div>
<?php
	}
}