<?php
class Calendarista_BookingOptionalsTmpl extends Calendarista_TemplateBase{
	public $optionalGroups;
	public $optionals;
	public $optionalStateBag;
	public $costHelper;
	public $optionalsHelper;
	public function __construct($stateBag = null){
		parent::__construct($stateBag);
		$optionalGroupRepo = new Calendarista_OptionalGroupRepository();
		$optionalRepo = new Calendarista_OptionalRepository();
		$this->optionalGroups = $optionalGroupRepo->readAll($this->projectId);
		$this->optionals = $optionalRepo->readAll($this->projectId);
		$this->costHelper = new Calendarista_CostHelper($this->viewState);
		$this->optionalsHelper = $this->costHelper->optionalsHelper;
		$this->optionalStateBag = $this->getViewStateValue('optionals') ? array_map('intval', explode(',', $this->getViewStateValue('optionals'))) : array();
		$this->render();
	}
	public function selectedValue($value){
		return in_array($value, $this->optionalStateBag) ? 'selected=selected' : null;
	}
	public function checked($value){
		return in_array($value, $this->optionalStateBag) ? 'checked="true"' : null;
	}
	public function renderDropdownList($group){
	?>
		<select id="optional_group_<?php echo $group->id ?>" 
			name="optional_group_<?php echo $group->id ?>[]" 
			class="form-control calendarista-typography--caption1 calendarista-optional calendarista_parsley_validated"
			<?php echo $group->displayMode === 3 ? 'multiple' : ''?>
			<?php if($group->minRequired > 0):?>
			data-parsley-required="true"
			<?php endif;?>
			<?php if($group->minRequired > 0 && $group->displayMode === 3/*listbox*/):?>
				data-parsley-mincheck="<?php echo $group->minRequired?>"
			<?php endif;?>>
		<?php foreach($this->optionals as $optional):?>
			<?php if($optional->groupId !== $group->id){continue;}?>
			<option value="<?php echo $optional->id?>" <?php echo !$optional->hasQuantity() ? 'disabled' : '' ?> 
				<?php echo $this->selectedValue($optional->id); ?>><?php echo $this->optionalsHelper->formatOptionalItemCaption($optional, $group); ?></option>
		<?php endforeach;?>
		</select>
		<?php if($group->displayMode === 3):?>
		<div class="calendarista-text calendarista-typography--caption1">
			<p><?php echo $this->stringResources['OPTIONAL_LISTBOX_NOTE']?></p>
		</div>
		<?php endif;?>
	<?php 
	}
	public function renderInput($group){
		$type = $group->displayMode === 0 ? 'checkbox' : 'radio';
		$j = 0;
	?>
		<?php for($i = 0; $i < $this->optionals->count(); $i++):?>
			<?php $optional = $this->optionals->item($i);
				if($optional->groupId !== $group->id){continue;}?>
		<div class="form-check">
			<label class="form-check-label calendarista-typography--caption1">	
				<input type="<?php echo $type; ?>" value="<?php echo $optional->id?>"  
					class="form-check-input calendarista-optional calendarista_parsley_validated"
					<?php if(($type === 'checkbox' && $group->minRequired) && $j === 0):?>
					data-parsley-mincheck="<?php echo $group->minRequired ?>"
					data-parsley-required="true"
					<?php endif;?>
					<?php if(($type === 'radio' && $group->minRequired) && $j === 0):?>
					checked
					<?php endif;?>
					 <?php if(!$optional->hasQuantity()):?>
					 disabled
					 <?php endif; ?>
						name="optional_group_<?php echo $group->id?>[]" <?php echo $this->checked($optional->id); ?>>
					<?php echo $this->optionalsHelper->formatOptionalItemCaption($optional, $group); ?>
			</label>
		</div>
		<?php $j++; ?>
		<?php endfor;?>
	<?php 
	}
	public function render(){
	?>
	<?php if($this->optionalGroups->count() > 0):?>
		<?php foreach($this->optionalGroups as $group):?>
			<div class="col-xl-12">
				<div class="form-group">
					<label class="form-control-label calendarista-typography--caption1" for="calendarista_group_<?php echo $group->id ?>">
						<?php echo Calendarista_StringResourceHelper::decodeString($group->name) ?>
					</label>
					<?php if (in_array($group->displayMode, array(2, 3))): 
						$this->renderDropdownList($group);
					else:
						$this->renderInput($group);
					endif;?>
				</div>
			</div>
	   <?php endforeach;?>
	<?php endif; ?>
	<script type="text/javascript">
	(function(){
		"use strict";
		function init(){
			var optionals = new Calendarista.optionals({
				'id': '<?php echo $this->uniqueId ?>'
				, 'projectId': <?php echo $this->projectId ?>
				, 'ajaxUrl': '<?php echo $this->ajaxUrl ?>'
			})
			, $nextButton;
			$nextButton = optionals.$root.find('button[name="next"]');
			$nextButton.on('click', function(e){
				if(!Calendarista.wizard.isValid(optionals.$root)){
					e.preventDefault();
					return false;
				}
				optionals.unload();
			});
		}
		<?php if($this->notAjaxRequest):?>
		
		if (window.addEventListener){
		  window.addEventListener('load', onload, false); 
		} else if (window.attachEvent){
		  window.attachEvent('onload', onload);
		}
		function onload(e){
			init();
		}
		<?php else: ?>
		init();
		<?php endif; ?>
		
	})();
	</script>
<?php
	}
}