<?php
class Calendarista_BookingServiceSwitcherTmpl extends Calendarista_TemplateBase{
	public $projects = array();
	public $projectId;
	public function __construct($projects){
		parent::__construct();
		if(count($projects) <= 1){
			return;
		}
		$repo = new Calendarista_ProjectRepository();
		$this->projects = $repo->readAll($projects);
		$this->render();
	}
	public function selectedValue($id){
		return $this->projectId === $id ? 'selected=selected' : '';
	}
	public function render(){
	?>
	<?php if($this->projects && $this->projects->count() > 0):?>
	<div class="col-xl-12">
		<div class="form-group">
			<label class="form-control-label calendarista-typography--caption1">
				<?php echo $this->stringResources['BOOKING_SERVICE_SELECTION_LABEL'] ?>
			</label>
			<select
				name="projects" 
				class="form-control calendarista-typography--caption1">
				<?php foreach($this->projects as $project):?>
				<option value="<?php echo $project->id ?>" <?php echo $this->selectedValue($project->id); ?>>
					<?php echo Calendarista_StringResourceHelper::decodeString($project->name) ?>
				</option>
				<?php endforeach; ?>
			</select>
		</div>
	</div>
	<?php endif; ?>
<?php
	}
}