<?php
class Calendarista_TimeslotStandardViewTmpl extends Calendarista_TemplateBase{
	public $container;
	public function __construct($container){
		parent::__construct();
		$this->container = $container;
		$this->render();
	}
	public function render(){
	?>
	<div class="<?php echo $this->container->placeholderClassName ?>">
		<div class="form-group calendarista-row-single">
			<div class="<?php echo !$this->container->multipleSlotSelection || $this->container->enableResetButton ? 'input-group' : '' ?>">
				<?php if(!$this->container->slotType):?>
				<input type="hidden" name="availabilityId" value="<?php echo $this->container->availabilityId ?>"/>
				<?php endif; ?>
				<?php if($this->container->multipleSlotSelection): ?>
					<label class="form-control-label calendarista-typography--caption1" for="<?php echo $this->container->fieldName . $this->uniqueId ?>">
						<?php echo $this->container->timeLabel ?>
					</label>
				<?php endif; ?>
				<select id="<?php echo $this->container->fieldName . $this->uniqueId ?>" name="<?php echo $this->container->fieldName ?>" 
					class="calendarista-time form-control calendarista-typography--caption1 calendarista_parsley_validated" 
					data-parsley-required="true"
					data-parsley-errors-container="#<?php echo $this->container->errorContainerId ?>_error_container"
					<?php if($this->container->multipleSlotSelection): ?>
					multiple="multiple"
					data-calendarista-max-timeslots="<?php echo $this->container->availability->maxTimeslots ?>"
					<?php endif;?>>
					<?php if(!$this->container->multipleSlotSelection): ?>
					<option value=""><?php echo $this->container->timeLabel ?></option>
					<?php endif; ?>
					<?php foreach($this->container->timeslots as $key=>$timeslot):?>
					<option value="<?php echo $timeslot->id?>" data-calendarista-time="<?php echo $this->container->formatTime($timeslot) ?>"
							<?php echo $this->container->selectedValue($timeslot);?>><?php echo $this->container->formatTime($timeslot) ?></option>
					<?php endforeach; ?>
				</select>
				<?php if($this->container->enableResetButton): ?>
				 <div class="input-group-append input-group-sm">
					<button type="button"  class="btn btn-outline-secondary calendarista-typography--button <?php echo $this->container->resetButton ?> calendarista-not-active" title="<?php echo $this->container->stringResources['BOOKING_RESET_TIME']; ?>" disabled><i class="fa fa-undo"></i></button>
				  </div>
				<?php endif; ?>
				<?php if(!$this->container->multipleSlotSelection): ?>
				<span class="input-group-append">
					<label class="input-group-text">
						<i class="fa fa-clock-o"></i>
					</label>
				</span>
				<?php endif;?>
			</div>
			<div id="<?php echo $this->container->errorContainerId ?>_error_container" class="calendarista-typography--caption1"></div>
			<?php if($this->container->multipleSlotSelection):?>
			<p class="calendarista-max-timeslot-message calendarista-typography--caption1 form-text text-muted">
				<span class="hidden-xs hidden-sm"><?php echo $this->container->stringResources['BOOKING_MULTI_SELECT_TIMESLOT_NOTICE']; ?></span>
				<span><?php echo sprintf($this->container->stringResources['BOOKING_MAX_TIMESLOT_NOTICE'], $this->container->availability->maxTimeslots); ?></span>
			</p>
			<?php endif; ?>
		</div>
		<div class="clearfix"></div>
	</div>
<?php
	}
}
