<?php
class Calendarista_ShortCodeGeneratorTemplate extends Calendarista_ViewBase{
	function __construct( ){
		parent::__construct(false, true, 'calendarista-settings');
		$this->render();
	}
	public function render(){
	?>
		<div class="widget-liquid-left">
			<div id="widgets-left">
				<div class="wrap">
					<div class="column-pane">
						<div class="calendarista-borderless-accordion">
							<div id="shortcode_gen">
								<h3><?php echo __('Services', 'calendarista') ?></h3>
								<p class="description"><?php echo __('Select one or more services below', 'calendarista') ?></p>
								<?php if($this->projects->count() > 0): ?>
								<div style="overflow: auto; height: 400px; width: 100%">
									<form data-parsley-validate action="<?php echo $this->requestUrl ?>" method="post"> 
										<table class="wp-list-table calendarista wp-list-table widefat fixed striped">
											<thead></thead>
											<tbody>
											<?php foreach($this->projects as $project):?>
											<tr>
												<td>
													<input type="checkbox" name="projects[]" value="<?php echo $project->id ?>" data-calendarista-name="<?php echo $project->name ?>"><?php echo $project->name ?><br>
												</td>
											</tr>
											<?php endforeach;?>
											</tbody>
										</table>
									</form>
								</div>
								<?php else: ?>
								<p class="description"><?php echo __('Please create at least one service first', 'calendarista') ?></p>
								<?php endif; ?>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
		<div class="widget-liquid-right">
			<div id="widgets-right">
				<div class="wrap">
					<div class="column-pane">
						<div class="calendarista-borderless-accordion">
							<div id="shortcode">
								<div id="multi_booking_section" class="hide">
									<p>
										<input type="checkbox" name="enableMultipleBookings"><?php echo __('Enable booking multiple availabilities', 'calendarista') ?>
									</p>
								</div>
								<h3><?php echo __('Result', 'calendarista') ?></h3>
								<div>
									<p class="description"><?php echo __('Select one or more services in the left pane. The resulting short-code to insert in a page or post will be printed below.', 'calendarista') ?></p>
									<textarea id="shortcode_result" style="width: 100%" rows="5" readonly></textarea>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
		<script type="text/javascript">
			(function($){
				var calendarista = window['calendarista'] ? window['calendarista'] : function(){};
				calendarista.createDelegate = function (instance, method) {
					return function () {
						return method.apply(instance, arguments);
					};
				};
				calendarista.shortcodeGen = function(options){
					var context = this;
					$(window).ready(function(){
						context.init(options);
					});
				};
				calendarista.shortcodeGen.prototype.init = function(options){
					var context = this;
					this.requestUrl = options['requestUrl'];
					this.$projectList = $('input[name="projects[]"]');
					this.$multiBookingSection = $('#multi_booking_section');
					this.$enableMultipleBookings = $('input[name="enableMultipleBookings"]');
					this.$output = $('#shortcode_result');
					this.outputShortCodeDelegate = calendarista.createDelegate(this, this.outputShortCode);
					this.$enableMultipleBookings.on('change', function(e){
						context.outputShortCode();
					});
					this.$projectList.on('change', this.outputShortCodeDelegate);
				};
				calendarista.shortcodeGen.prototype.outputShortCode = function(){
					var $checkedItems = $('input[name="projects[]"]:checked')
						, checkedValues = $checkedItems.map(function () {
						return this.value;
					}).get()
					, output;
					//reset
					this.$output.val('');
					if(checkedValues.length > 0){
						this.$multiBookingSection.removeClass('hide');
						output = '[calendarista-booking id="' + checkedValues.join(',') + '"';
						if(this.$enableMultipleBookings.is(':checked')){
							output += ' enable-multiple-booking="true"';
						}
						output += ']';
						this.$output.val(output);
					}else{
						this.$multiBookingSection.addClass('hide');
					}
				};
			window['calendarista'] = calendarista;
		})(window['jQuery']);
		new calendarista.shortcodeGen({
			'requestUrl': '<?php echo $this->requestUrl ?>'
			, 'ajaxUrl': '<?php echo admin_url('admin-ajax.php')?>'
		});
		</script>
		<?php
	}
}